package cn.iocoder.yudao.module.system.api.dept;

import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.system.api.dept.dto.DeptRespDTO;
import cn.iocoder.yudao.module.system.controller.admin.dept.vo.dept.DeptSaveReqVO;
import cn.iocoder.yudao.module.system.dal.dataobject.dept.DeptDO;
import cn.iocoder.yudao.module.system.dal.redis.RedisKeyConstants;
import cn.iocoder.yudao.module.system.service.dept.DeptService;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.context.annotation.Lazy;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collection;
import java.util.List;
import java.util.Set;

/**
 * 部门 API 实现类
 *
 * @author 芋道源码
 */
@Service
public class DeptApiImpl implements DeptApi {

    @Resource
    private DeptService deptService;

    /**
     * 创建部门信息
     * @param deptRespDTO 部门对象
     * @return 部门id
     */
    @Override
    public Long saveDept(DeptRespDTO deptRespDTO) {
        DeptSaveReqVO deptSaveReqVO = BeanUtils.toBean(deptRespDTO,DeptSaveReqVO.class);
        return deptService.createDept(deptSaveReqVO);
    }

    /**
     * 批量删除部门
     *
     * @param ids 部门ids
     * @author vinjor-M
     * @date 17:17 2024/8/3
     **/
    @Override
    public void deleteDept(Set<Long> ids) {
        deptService.deleteDept(ids);
    }

    @Override
    public DeptRespDTO getDept(Long id) {
        DeptDO dept = deptService.getDept(id);
        return BeanUtils.toBean(dept, DeptRespDTO.class);
    }

    /**
     * 获得部门信息
     *
     * @param parentId 上级部门编号
     * @return 部门信息
     */
    @Override
    public DeptRespDTO getDeptByParentId(Long parentId) {
        DeptDO dept = deptService.getDeptByParentId(parentId);
        return BeanUtils.toBean(dept, DeptRespDTO.class);
    }

    /**
     * 获得部门信息
     *
     * @param parentId 上级部门编号
     * @param name     上级部门名称
     * @return 部门信息
     */
    @Override
    public DeptRespDTO getDeptByParentIdAndName(Long parentId, String name) {
        DeptDO dept = deptService.getDeptByParentIdAndName(parentId,name);
        return BeanUtils.toBean(dept, DeptRespDTO.class);
    }

    @Override
    public List<DeptRespDTO> getDeptList(Collection<Long> ids) {
        List<DeptDO> depts = deptService.getDeptList(ids);
        return BeanUtils.toBean(depts, DeptRespDTO.class);
    }

    @Override
    public void validateDeptList(Collection<Long> ids) {
        deptService.validateDeptList(ids);
    }

    @Override
    public List<DeptRespDTO> getChildDeptList(Long id) {
        List<DeptDO> childDeptList = deptService.getChildDeptList(id);
        return BeanUtils.toBean(childDeptList, DeptRespDTO.class);
    }

}
